;;;  Parallel sorting with multiple keys -- technique suggested by E.S. Yu
;;;  Compiled version

(*PROCLAIM '(type (FIELD-PVAR 20) K1 K2 K3 R R1 R2))

(*DEFVAR K1 (random!! (!! 100000)))
(*DEFVAR K2 (random!! (!! 500000)))
(*DEFVAR K3 (random!! (!! 900000)))

(*DEFVAR R  (!! 0))
(*DEFVAR R1 (!! 0))
(*DEFVAR R2 (!! 0))

(*PROCLAIM '(type (FIELD-PVAR 40) Q1 Q2))

(*DEFVAR Q1 (!! 0))
(*DEFVAR Q2 (!! 0))

(*DEFVAR S (!! 0))

(defvar kbits 20)   ;; Number of bits in ranks

(setq *print-array* t)

;;; Sort according to k1, k2, k3

(*defun sort3 (k1 k2 k3)
  (*set R1 (rank!! k3 '<=!!))
  (*set Q1 (+!! (ash!! k2 (!! kbits)) R1))
  (*set R2 (rank!! Q1 '<=!!))
  (*set Q2 (+!! (ash!! k1 (!! kbits)) R2))
  (*set R (rank!! Q2 '<=!!))
)
